#include <p24Fxxxx.h>
//#include<adc.h>


//_CONFIG2(FNOSC_PRIPLL & POSCMOD_XT) // Primary XT OSC with PLL
_CONFIG2(FNOSC_FRCPLL & POSCMOD_NONE & OSCIOFNC_ON) // Primary XT OSC with PLL
_CONFIG1(JTAGEN_OFF & FWDTEN_ON & ICS_PGx1 & GCP_ON)   // JTAG off, watchdog timer off

/*
PicKit2 BROYG
*/

/*
          registr AD9854
             |
            \|/
buff_data[xxxxxx] = chto pishem w registr

       kakie registry nuzno obnowlat'
        |
regist[xxxx]
*/

unsigned char buff_data[40], buff_adr[10], stop_flag, wr, rst, addres, buff_tmp; 
unsigned int count_data, count_adr;
unsigned char regist[30], count_regist;
unsigned long long int freq, freq_kod;

//#define Nop() {__asm__ volatile ("nop");}

#define ClrWdt() {__asm__ volatile ("clrwdt");}


#define dds_di 		PORTAbits.RA4
#define dds_cs 		LATAbits.LATA8
#define dds_do 		LATAbits.LATA9
//#define tris_do 	TRISAbits.TRISA9
#define dds_clk		LATCbits.LATC3
#define dds_reset 	LATAbits.LATA3
#define fq_update	LATAbits.LATA2


#define dds_strobe ((LATCbits.LATC3 = 1), (LATCbits.LATC3 = 0)) 

void DelayMs(unsigned long ms)
  {ms *= 1455;  
    while (ms) {ms --; 
                ClrWdt(); 
               }            
  }
void delay(unsigned long ms1)
  {//ms1 *= 14;  
    while (ms1) {ms1 --; 
                ClrWdt(); 
               }            
  }

void write_dds(unsigned char adr, unsigned long long dannye, unsigned char dlinna)
  {unsigned char tmp;
   dds_cs = 0;  
   
	 for (tmp = 0; tmp < 8; tmp++)
   	         {  if (adr & 1) dds_do = 1;
                        else dds_do = 0;   
               adr >>= 1;               
               dds_strobe;
              
            	}          	
      for (tmp = 0; tmp < dlinna; tmp++)
   	         {  if (dannye & 1) dds_do = 1;
                           else dds_do = 0;   
               dannye >>= 1;
               dds_strobe;
               
            	}          	           
	dds_cs = 1;
	fq_update = 1;
	delay(1);
	fq_update = 0;
  } 



void dds_init(void)
  {unsigned char tmp;
  
   unsigned long f;

 f = 0b00000000110000000000000000000000;  // LSB first SDIO only
  //f = 0;
	dds_cs = 0; 
	dds_do = 0;	  
    for (tmp = 0; tmp < 8; tmp++) dds_strobe;
             
   	for (tmp = 0; tmp < 32; tmp++)
   	         {  if (f & 1) dds_do = 1;
                      else dds_do = 0;   
                f >>= 1;
                dds_strobe;              
            	}	        	
	dds_cs = 1;
	fq_update = 1;
	delay(1);
	fq_update = 0;
   }


void system_init(void)
 {//*************************************
// Unlock Registers
//*************************************
asm volatile ( "MOV #OSCCON, w1 \n"
"MOV #0x46, w2 \n"
"MOV #0x57, w3 \n"
"MOV.b w2, [w1] \n"
"MOV.b w3, [w1] \n"
"BCLR OSCCON,#6");
//***************************
// Assign INT1 To Pin RP21
// Assign INT2 To Pin RP20
//***************************
RPINR0bits.INT1R = 21;
RPINR1bits.INT2R = 20;
//*************************************
// Lock Registers
//*************************************
asm volatile ( "MOV #OSCCON, w1 \n"
"MOV #0x46, w2 \n"
"MOV #0x57, w3 \n"
"MOV.b w2, [w1] \n"
"MOV.b w3, [w1] \n"
"BSET OSCCON, #6" );
 T2CON = 0b0000000000000000; //4ms
 TMR2 = 48000; //1ms
 IFS0bits.T2IF = 0;
 IEC0bits.T2IE = 1; //enable interrupt TMR2
 
 INTCON2bits.INT1EP = 0; //positiv interrupt
 INTCON2bits.INT2EP = 0; //positiv interrupt 
 IFS1bits.INT1IF = 0;
 IFS1bits.INT2IF = 0;
 IEC1bits.INT1IE = 1; //enable interrupt 1
 IEC1bits.INT2IE = 1; //enable interrupt 2
 
 } 

void check_regist(void)
 {unsigned char tmp, freq_update, mult_update, mult, bypass_pll;
  freq_update = 0;	 
  mult_update = 0;
  mult = 0;
  bypass_pll = 0;
  for (tmp = 0; tmp < count_regist; tmp ++)
    {if (regist[tmp] == 0x04) {buff_adr[4] = buff_data[0x04];
	                           freq_update = 1;
	                          }                        
	 if (regist[tmp] == 0x05) {buff_adr[5] = buff_data[0x05];
		                       freq_update = 1;
	                          }   
	 if (regist[tmp] == 0x06) {buff_adr[6] = buff_data[0x06];
		                       freq_update = 1;
	                          }   
	 if (regist[tmp] == 0x07) {buff_adr[7] = buff_data[0x07];
		                       freq_update = 1;
	                          }   
	 
	 if (regist[tmp] == 0x1E) {mult = buff_data[0x1E] & 0b11111;
		                       bypass_pll = (buff_data[0x1E] >> 5 ) & 1;
		                       mult_update = 1;
		                      }                       
	}
  if (freq_update)
        {freq_kod = buff_adr[0x04];
	     freq_kod <<= 8;
	     freq_kod += buff_adr[0x05];
	     freq_kod <<= 8;
	     freq_kod += buff_adr[0x06];
	     freq_kod <<= 8;
	     freq_kod += buff_adr[0x07];
	     freq = freq_kod;//freq = freq_kod * 2; //itog freq * 4
	     
	     if (freq > 0x10F5C28) write_dds(4, freq, 32); //if (freq > 0x28F5C28) write_dds(4, freq, 32);
	     //if (freq > 0x28) write_dds(4, freq, 32);
	    }
  if (mult_update)
      {mult <<= 3;
	   mult += 0b100;
	   write_dds(1, mult, 24);
	   }
 }
// ****************************************************************************************
// ================================ M A I N ==========================================
int main(void)
{TRISA = 0b10000;
 TRISB = 0xFFFF;
 TRISC = 0b110000;
 
 CLKDIV = 0b0011000000000000; //8MHz * 4 = 16MIPS
 AD1PCFG = 0xFFFF;

 system_init();
 
 dds_cs = 1;
 dds_reset = 1;
 DelayMs(500);

 dds_reset = 0;
 freq = 0x08F61672;
 freq *= 2;
 dds_init();
 write_dds(1, 0x00002C, 24);
write_dds(2, 0x3FFF, 16);
 write_dds(4, freq, 32);
 
 //freq_to_dds(freq);
 count_adr = 0;
 count_data = 0;
 stop_flag = 0;
 count_regist = 0;
 wr = 1;
 
 while (1)
  {ClrWdt();
  if (stop_flag)
        {wr = 1;
	     check_regist();
	     
	     stop_flag = 0;
	    // count_adr = 0;
        // count_data = 0;
         count_regist = 0;
      
	     }
  }

 return 1;
 } // ---------- END MAIN ---------------

void __attribute__((interrupt, no_auto_psv)) _T2Interrupt(void)
  {
   TMR2 = 62500; // 128uS 48000=1ms, 57500 = 500uS
   stop_flag = 1;
   T2CONbits.TON = 0;
   IFS0bits.T2IF = 0;
  }
void __attribute__((interrupt, no_auto_psv)) _INT1Interrupt(void)
  {if (PORTCbits.RC5)
   {buff_tmp = PORTB >> 8;
   //count_adr ++;
   TMR2 = 62500;
   T2CONbits.TON = 1;
   }
   IFS1bits.INT1IF = 0;
   
  }
void __attribute__((interrupt, no_auto_psv)) _INT2Interrupt(void)
  {if (PORTCbits.RC4)
   {addres = ((PORTB >> 8) & 0b111111);
   wr = ((PORTB >> 14) & 1);
   rst = ((PORTB >> 15) & 1);
   if (!wr) 
        {buff_data[addres] = buff_tmp;
         regist[count_regist] = addres; //kakie registry pomenijalis'
         count_regist ++;
         
        } 
   
   //count_data ++;
   TMR2 = 62500;
   T2CONbits.TON = 1;
   }
   IFS1bits.INT2IF = 0;
    
  }

